[![GitHub issues](https://img.shields.io/github/issues/TrainingByPackt/Artificial-Intelligence-and-Machine-Learning-Fundamentals.svg)](https://github.com/TrainingByPackt/Artificial-Intelligence-and-Machine-Learning-Fundamentals/issues)
[![GitHub forks](https://img.shields.io/github/forks/TrainingByPackt/Artificial-Intelligence-and-Machine-Learning-Fundamentals.svg)](https://github.com/TrainingByPackt/Artificial-Intelligence-and-Machine-Learning-Fundamentals/network)
[![GitHub stars](https://img.shields.io/github/stars/TrainingByPackt/Artificial-Intelligence-and-Machine-Learning-Fundamentals.svg)](https://github.com/TrainingByPackt/Artificial-Intelligence-and-Machine-Learning-Fundamentals/stargazers)
[![PRs Welcome](https://img.shields.io/badge/PRs-welcome-brightgreen.svg)](https://github.com/TrainingByPackt/Artificial-Intelligence-and-Machine-Learning-Fundamentals/pulls)



# Artificial Intelligence and Machine Learning Fundamentals
Machine learning and neural networks are fast becoming pillars on which you can build intelligent applications. The course will begin by introducing you to Python and discussing using AI search algorithms. You will learn math-heavy topics, such as regression and classification, illustrated by Python examples.

You will then progress on to advanced AI techniques and concepts, and work on real-life data sets to form decision trees and clusters. You will be introduced to neural networks, which is a powerful tool benefiting from Moore's law applied on 21st-century computing power. By the end of this course, you will feel confident and look forward to building your own AI applications with your newly-acquired skills!



## What you will learn
* Understand the importance, principles, and fields of AI
* Learn to implement basic artificial intelligence concepts with Python
* Apply regression and classification concepts to real-world problems
* Perform predictive analysis using decision trees and random forests
* Perform clustering using the k-means and mean shift algorithms
* Understand the fundamentals of deep learning via practical examples



### Hardware requirements
For an optimal student experience, we recommend the following hardware configuration:
* **Processor**: 2.6 GHz or higher, preferably multi-core
* **Memory**: 4GB RAM
* **Hard disk**: 35 GB or more
* An Internet connection



### Software requirements
You’ll also need the following software installed in advance:
* __Operating System__: Windows 7 SP1 64-bit, Windows 8.1 64-bit or Windows 10 64-bit, Ubuntu Linux, or the latest version of OS X
* __Browser__: Google Chrome, latest version
* Anaconda, latest version
* IPython latest version






